#include <cstdlib>
#include <iostream>
#include <exception>
#include <typeinfo>
#include "Person.h"

using namespace std;

void callADynamicAllocation()
{
    int* myarray = NULL;
    if(myarray){
        cout << "Not NULL" << endl;
    }else{
        cout << "Is NULL" << endl;
    }
    try {
        int *myarray = new int[1000000000];
        std::cout << "Calling typeid: " << typeid (myarray).name() << std::endl;
    }
    catch(exception & e){
        cout << "Standard exception: " << e.what() << endl;
        if(myarray){
            cout << "Not NULL" << endl;
        }else{
            cout << "Is NULL" << endl;
        }
    }
    if(myarray){
        cout << "Deleting myarray" << endl;
        delete myarray;
    }
    cout << "Returning" << endl;
}

void callADynamicAllocationNoExceptionHandler()
{
    int *myarray = new int[1000000000];
    std::cout << "Calling typeid: " << typeid (myarray).name() << std::endl;

    if(myarray) {
        cout << "Deleting myarray" << endl;
        delete myarray;
    }
    cout << "Returning" << endl;
}

int main () {
//    callADynamicAllocationNoExceptionHandler();
	callADynamicAllocation();

    return 0;
}
